freeslot("sfx_uncurl")
local timervar = 5
local function BitCounter(var)
	local count = 0
	local i = var
	while (i) do
		count = $ + (i & 1)
		i = $ >> 1
	end
	return count
end
local function EmeraldCount(player)
	local var = 0
	if player and (gametyperules&GTR_POWERSTONES) then
		var = player.powers[pw_emeralds]
	elseif player then
		var = emeralds
	end
	return BitCounter(var)
end
//Tumbledash handling code below
local function TumbleDash(player)//adapted from drop dash code
	//if skins[player.skin].name == "nicky" then//these values still need to change if player.mo.skin is altered without changing player.skin
		if player.mo.tumble == nil then
			player.mo.tumble = 0//tumble inactive
			player.mo.prevmomz = 0
			player.prevanim = player.panim
			player.contrtimer = 0 //stasis was interfering with the respin so i'm using this instead of pw_nocontrol
		elseif player.mo.skin == "nicky" then//in case I ever reimplement the Sonic Mode mechanic 
			local mo = player.mo
			if mo.tumble == 1 and P_IsObjectOnGround(mo) and mo.state == S_PLAY_ROLL then
				local temp = 2*((6 - min(6,player.emercount))*FRACUNIT)/(5 +(2*player.emercount))
				temp = FixedAngle(temp)
				if P_RandomChance(FRACUNIT/2) then temp = InvAngle(temp) end
				player.drawangle = $ + temp
				P_InstaThrust(player.mo, player.drawangle, FixedHypot(player.rmomx,player.rmomy))
			elseif (mo.eflags & MFE_JUSTHITFLOOR)
			and ((player.prevanim == PA_ROLL) or (mo.spinjump and (player.prevanim == PA_JUMP))) 
			and not mo.tumble then //a tic-perfect sweetspot to jump.
				player.mo.spinjump = false
				player.mo.tumble = 2//tumble start
				player.mo.state = S_PLAY_SPINDASH
				player.pflags = $1|PF_STARTDASH
				player.contrtimer = 0 
			elseif mo.tumble == 2 and P_IsObjectOnGround(mo) then 
				S_StartSound(mo, sfx_zoom, player)
				local speed = abs(mo.prevmomz/2)+FixedHypot(player.rmomx,player.rmomy)
				local actionspd = player.actionspd
				if (player.powers[pw_super] or player.empower) then 
					actionspd = $*3/2 
					player.contrtimer = timervar
				else
					player.contrtimer = timervar * (10 - player.emercount)
				end
				if (mo.eflags&MFE_UNDERWATER) then actionspd = $*2/3 end
				local spdsum = actionspd + speed
				local thrustint = (((1+player.emercount)*spdsum/14) + spdsum)/3  
				if player.drawangle == nil then  
					P_InstaThrust(player.mo, player.mo.angle, thrustint)
					player.mo.tumbangle = player.mo.angle
				else 
					P_InstaThrust(player.mo, player.drawangle, thrustint)
					player.mo.tumbangle = player.drawangle 
				end
				player.mo.tumble = 1//tumble active
				player.mo.state = S_PLAY_ROLL
				player.pflags = $1|PF_SPINNING
			elseif mo.tumble == 2 
			or not mo.state == S_PLAY_ROLL then
				player.mo.tumble = 0
			end
			player.mo.prevmomz = mo.momz
			player.prevanim = player.panim
		elseif player.mo.tumble or player.contrtimer then
			player.mo.tumble = 0
			player.contrtimer = 0
		end
	//end
end

addHook("PreThinkFrame", function()
	for player in players.iterate() do
		if player.mo.skin == "nicky" then 
			player.emercount = EmeraldCount(player)
			player.mo.smscompatibleskin = 2
			if player.contrtimer then
				player.cmd.forwardmove = 0
				player.cmd.sidemove = 0
				player.cmd.angleturn = player.drawangle>>16 //yeah this works
				player.cmd.buttons = $ & ~(BT_ATTACK|BT_USE|BT_TOSSFLAG|BT_JUMP|BT_FIRENORMAL)
			elseif player.mo.tumble == 1
				player.mo.tumble = 0
			end
			//if (player.powers[pw_super] or player.empower) then
			//	return
			//end
		end
	end
end)
addHook("MobjMoveBlocked", function(mobj, thing, line)
	local player = mobj.player
	if mobj.skin == "nicky" 
		if (player.powers[pw_super] or player.empower) then
			return
		elseif line and (mobj.player.contrtimer
		or ((player.emercount<2) and (mobj.state == S_PLAY_ROLL or (mobj.spinjump and mobj.state == S_PLAY_JUMP)))) then
			local f = player.powers[pw_flashing]
			P_DoPlayerPain(mobj.player)
			player.powers[pw_flashing] = f
			mobj.tumble = 0
		end
	end
end, MT_PLAYER)	
//Spin and curl toggling code below
local function SpinjumpOn(player)
	player.charflags = $ &~SF_NOJUMPSPIN
	player.pflags = $ &~PF_NOJUMPDAMAGE
	player.mo.spinjump = true
end
local function SpinjumpOff(player)
	player.charflags = $ |SF_NOJUMPSPIN
	player.pflags = $ |PF_NOJUMPDAMAGE
	player.mo.spinjump = false
end
local function SpinjumpCheck(player)
	if player.mo and player.mo.valid and player.mo.skin == "nicky" //and player.mo.nickymode
	and player.pflags & PF_STARTJUMP then
		if (player.pflags & PF_SPINNING) then //if Nicky is spinning, he'll jump like Sonic
			SpinjumpOn(player)
		else								//otherwise, he'll jump like Amy and Fang
			SpinjumpOff(player)
		end
	end
end
local function CurlToggle(player) //assigned a local function for ease of editing
	if player.mo and player.mo.valid and player.mo.skin == "nicky" then 
		if not player.abilitimer then
			player.abilitimer = (15*TICRATE/7) - (player.emercount*(2*TICRATE/7)) - 1 //set ability timer
			player.pflags = $ &~PF_JUMPED //disable jump flag so nojumpspin and nojumpdamage can be retriggered
			local mo = player.mo
			if (mo.momz > 0)
				mo.state = S_PLAY_SPRING //transition state is spring if rising
			else
				mo.state = S_PLAY_FALL //or fall otherwise
			end
			if mo.spinjump then
				SpinjumpOff(player)
				S_StartSound(mo,sfx_uncurl)
				S_StopSoundByID(mo,sfx_spin)
			else
				SpinjumpOn(player)
				S_StartSound(mo,sfx_spin)
				S_StopSoundByID(mo,sfx_uncurl)
			end
			player.mo.state = S_PLAY_JUMP //retrigger jump state
			player.pflags = $ |PF_JUMPED //and just to make sure the flag is set
		end
		return true
	end
end
//Timer code below
local function IterateTimer(player)
	if player.abilitimer then 
		player.abilitimer = max(0, $ - 1) end
	if player.contrtimer then 
		player.contrtimer = max(0, $ - 1) end
end
local function ResetTimer(player, skipcheck)
	if skipcheck
	or player.powers[pw_justsprung]
	or player.panim == PA_IDLE
	or (player.mo.eflags & MFE_JUSTHITFLOOR and not player.mo.tumble) 		
	then
		player.abilitimer = 0
		player.contrtimer = 0
	end
end
addHook("MobjDamage", function(target, p, p)
    if p and p.skin == "nicky" then
		ResetTimer(p.player, 1)
		if p.spinjump
			CurlToggle(p.player)
			ResetTimer(p.player, 1)
		end
	end
end)
addHook("PostThinkFrame", function()
	for player in players.iterate() do
		if player.mo.skin == "nicky" then
			IterateTimer(player)
			ResetTimer(player, 0)
		end
	end
end)
//hooks
addHook("PlayerThink", TumbleDash)		
addHook("JumpSpecial", SpinjumpCheck)
addHook("AbilitySpecial", CurlToggle)